///home/berryj/link/bin/genMethods "-g" "-t" "Set<Edge*>" "-h" "List" "-I" "LINK/graph/Edge.h" "-I" "LINK/basic/Set.h" "-I" "LINK/basic/List.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Edge.h>

#include <LINK/basic/Set.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Set<Edge*> _Set_Edge__;
typedef List<Set<Edge*> > _List_Set_Edge___;
static List<Set<Edge*> > s__List_Set_Edge___;

#define _List_Set_Edge___DATA(x) ((List<Set<Edge*> >*) (EXTDATA(x)))
#define _List_Set_Edge___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Set<Edge*> > >::type))
#define _List_Set_Edge___ISNT_DATA(x) (!_List_Set_Edge___IS_DATA(x))

#define _List_Set_Edge___CXX_DATA(x) (*(List<Set<Edge*> >*) (EXTDATA(VAL(x))))
#define _List_Set_Edge___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Set<Edge*> > >::type))
#define _List_Set_Edge___CXX_ISNT_DATA(x) (!_List_Set_Edge___CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Set_Edge___()
{
	Wrapper<_List_Set_Edge___>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Set_Edge___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Set_Edge__>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Set_Edge__>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Set_Edge__>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Set_Edge___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Set_Edge___Methods(void);

PRIMITIVE STk_init_methods__List_Set_Edge___()
{
	STk_add_new_cpp_primitive("List-Set-Edge-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_Edge__>::makeLinkList);
	STk_add_new_cpp_primitive("List-Set-Edge?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_Edge__>::linkListP);
	STk_add_new_cpp_primitive("list->List-Set-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_Edge__>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Set-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_Edge__>::linkList2STkList);
	genExtra_List_Set_Edge___Methods();
	return UNDEFINED;
}
